(* Premiers pas avec le (O)Caml TopLevel *)
1+2;; 
4/(2*2);; 
fun x->x*x;; 

(*** Dfinitions ***)
let x = 2*5+1;; 
let pi = 3.1416;; 
let square = fun x ->x*x;; 

(* Dfinitions locales *)
let x= 2*5+1;;
let x= 2 in x*x;; 
x;; 
let a = 1 and b = 2 in 2*a+b;; 
let a=1 in let b=2*a in b+a;; 
let a=1 and b=2*a in b+2+a;;

(* 
   "where" est un mot cls en CAMLlight 
   mais pas en OCAML
*)
x*x where x=2;;
2*a+b where a=1 and b=2;;
b where b=2*a where a=1;;
a+b where b=2*a where a=1;;
(a+b where b=2*a) where a=1;;

(*** Types lmentaires ***)

(* int et float *)
3.45;;
3.45 E 10;;
3.45E10;;
3.45e10;;
int_of_float 1.;;
int_of_float 1.1;;
float_of_int 76;;
1.1+2.2;;
1.1 +. 2.2;;

(* CAMLlight *) 
#open float;;
#open "float";;
1.1 + 2.2;;
1+2;;
#close "float";;


(* Booleens *)
1<2;;
1<=2;;
0<1 & 3<9;;
true & false;;
let x=3 in if x=0 then 0 else 7/x;;
if true then 1 else 0.;;
if true then 1 else 0;;
"ceci est une"^" chaine de caracteres";;
"ceci est une"  ^  "chaine de caracteres";;

(* 
   La syntaxe pour les caractres est diffrent entre 
   CAMLlight et OCAML 
*)
'a';;
`a`;;
"a";;
int_of_char `a`;;
int_of_char 'a';;
char_of_int 97;;
1,2,3;;
1,2;;
1, (2,3);;
("COUCOU" , 3.1, (`A`,2));;
("COUCOU" , 3.1, ('A',2));;
(TRUE & FALSE, 3+3);;
true & false, 3+3;;

(* Produit Cartsiens *)
fst;;
snd;;
let x=(1,"coucou") and y=("hello",2.1) in (snd x, fst y);;
(fun x -> x*x) 4;;

(*** Fonctions ***)
square 4;;
square 2+3;;
square (2+3);;

(* 
   CAMLlight : Trois faons de dfinir la mme fonctions 
*)  
let F = fun x -> fun y-> x*y;;
let F = fun x y -> x*y;;
let F x y = x*y;;
F 2 34;;
let triple = F 3;;
triple 21;;

(* 
   OCAML : les identificateurs 
   contenant des majuscules sont rserves aux modules 
*)
let f = fun x -> fun y-> x*y;;
let f = fun x y -> x*y;;
let f x y = x*y;;
f 2 34;;
let triple = f 3;;
triple 21;;

(* 
   Cette fonction est polymorphe 
   On a dej vu des autres fonctions polymorphes, lesquelles ?
*)
let comp f g x = f (g x);;
comp square triple 4;;
comp square;;
let f = comp square int_of_float;;
f 4.1;;
let triple = fun x -> F 3 x;;

(* 
   CAMLlight : 
   Oprateur infixe -> fonction prfixe 
*)
prefix &;;
prefix & true false;;
prefix & true;;
& true false;;
prefix <;;

(* 
   CAMLlight :
   Fonction prfixe -> oprateur infixe  
*)
let sq = fun x -> x *.x;;
let o = fun f g x->f(g(x));;
o sq sq 2.;;
#infix "o";;
(sq o sq) 2.;;
sq o sq 2.;;
o sq sq 2.;;
#uninfix "o";;
o sq sq 2.;;

(* 
   OCAML :
   Types des oprateurs infixes
   Dfinition des oprateurs (infixes)
   Il contiennent seulement des symboles comme
   * + @ ... main non [a-zA-Z0-9]
*)
+ ;;
( + );;
let sum x y = x + y;;
let ( @ ) f g = fun x -> f(g(x));;
(sq @ sq) 2.;;
@ sq sq 2.;;

(* Fonctions rcursives *)
let x = 1;;
let x = x+2;;
let x = let x=1 in x+2;;
let x = x+2 where x=1;;


let rec fact n = if n=0 then 1 else n*fact(n-1);;
(fact 4);;
(* O est le problme avec cette la dfinition rcursive suivante ? *)
let rec fact n= if n=0 then 1 else n*(fact n-1);;
(fact 4);;

let rec f = (fun n-> (if n=0 then 1 else n*f(n-1)));;
(f 4);;
let rec puiss n x= if n=0 then 1. else x*.(puiss (n-1) x);;
puiss 2 3.;;
(puiss 200000 1.0);;

let rec puiss n x = if n=0 then 1.
                           else
                              let p =(puiss (n/2) x) in
                                if (n mod 2)=0 then 
                                   p*.p
                                else 
                                   p*.p*.x;;
puiss 10 2.;;
puiss 2000000 1.0;;
puiss 20000000000 1.;;
let rec puiss_bad n x = 
        if n=0 then 1.
        else
         if (n mod 2)=0 then 
            (puiss_bad (n/2) x)*.(puiss_bad (n/2) x)
         else x*.(puiss_bad ((n-1)/2) x)*.(puiss_bad ((n-1)/2) x);;
puiss_bad 20000000 1.;;

let rec even n = if n=0 then true
                        else odd(n-1)
    where rec
        odd n = if n=0 then false 
                       else even(n-1);;
even;;
odd;

let rec even n = if n=0 then true
                        else odd(n-1)
    and
        odd n = if n=0 then false 
                       else even(n-1);;
even;;
odd;;

(*** Un exemple un peu plus complexe ***) 

let rec fibo1 n = 
  if n = 0 then 0 
  else
    if n = 1 then 1
    else fibo1 (n-2) + fibo1 ( n-1);; 

let fibo2 n =
  let rec
    fibpair n =
    if 
      n = 0 then (0,1)
    else
      let 
	(x,y) = fibpair (n-1)
      in
	(y,x+y)
  in
    fst (fibpair n) 
;;

(*** 
  Un autre exemple : itration de Newton 
  pour CAMLlight : changer < en <. > en >.
***) 

let rec until predicat changer x =
  if predicat(x) then x
  else 
    until predicat changer (changer(x)) 


let deriv f x dx = (f(x +. dx) -. f(x)) /. dx ;;
let abs x = if x > 0.0 then x else -. x ;;

let newton f epsilon = 
  let
    ok y = abs(f y) < epsilon 
  and
    ameliorer y = y -. (f(y) /. (deriv f y epsilon))
  in 
    until ok ameliorer
;;

let racine_carre x epsilon =
  newton (function y -> y *. y -.x) epsilon x ;;

let racine_cube x epsilon =
  newton (function y -> y *. y *. y -.x) epsilon x ;;
