
(** Dfinition de types **)


(* Produits et records *)

();;
let expr = fun () -> 3 + 5;;
let expr () = 3 + 5;;
type nocomplexe = { re: float; im :float};;
let zero = {re=0.;im=0.};;
let multcomplexe  x y = 
  let
    partiereelle = x.re *. y.re -. x.im *.y.im
  and
    partieimaginaire = x.re *. y.im +. x.im *. y.re 
  in
    { re= partiereelle ; im = partieimaginaire };;

(* Sommes avec constructeurs *)

type traffic_light = Red | Green | Orange;;
type jour = Lu | Ma | Me | Je | Ve | Sa | Di;;
Lu;;
type bool = Vrai | Faux;;
let ou t1 = match t1  with
               Vrai    -> (fun x -> Vrai)
             | Faux   -> (fun x -> x);;
type num = Int of int | Fl of float;;
Int 3;;
Fl 3.;;
let add_num = function (Int x1 , Int x2) -> Int (x1+x2)
                |  (Fl x1 , Fl  x2)  -> Fl  (x1+.x2)
                |  (Int x1 ,Fl  x2)  -> Fl (float_of_int x1+. x2)
                |  (Fl x1 , Int x2)  -> Fl (x1 +. (float_of_int x2));;
type extend_float = None | Some of float;;
let max_root a b c =   
  if a = 0. then None
  else 
  let 
    delta = b*.b -. 4.*.a *.c 
  in
  if delta <= 0. then None
  else
  if a>0. then 
    Some ((-.b +. sqrt delta)/.2.*.a)
  else 
    Some ((-.b -. sqrt delta)/.2.*.a);;
max_root (-.1.) 2. 3.;;
max_root 1. 1. 1.;;
let f a b c =
  match max_root a b c with
     (Some x) ->  abs_float x 
   |  None    ->  -1.;;
f 1. 1. 1.;;
f (-1.) 2. 3.;;
type extend_int = Min | Some of int | Max;;
type age = Old of int;;
type date = Year of int;;
Old 40;;
Year 1996;;

(* Types rcursifs *)

type liste = Nil | Cons of int*liste;;
let rec length = function Nil -> 0
  | (Cons(_,l)) -> length l+1;;
type int_tree = Leaf of int | Node of int_tree * int_tree;;
Node(Node(Leaf 1, Leaf 2), (Leaf 3));;
let rec nb_node = function (Leaf x)    -> 1
                     | (Node(x,y)) -> (nb_node x)+(nb_node y)+1;;
nb_node (Node(Node(Leaf 1, Leaf 2), (Leaf 3)));;
type 'a tree = Leaf of 'a | Node of 'a tree *'a tree;;
type int_tree = int tree;;
type 'a liste = Nil | Cons of 'a * 'a liste;;
type ('a,'b) term = Term of 'a * ('a,'b) term list | Var of 'b;;

(* Retour sur le filtrage *)

let centre_de_gravite  = fun (a1,a2) (b1,b2) (c1,c2) ->
                                ((a1+.b1+.c1)/.3. ,(a2+.b2+.c2)/.3.);;
centre_de_gravite  (1.,1.) (2.,2.) (3.,3.);;
centre_de_gravite (0.,0.) (1.,1.) (-1., -1.);;
let iso_barycentre a b c a' b' c'=
  match centre_de_gravite  a b c with
      (x, y) -> match centre_de_gravite a' b' c' with
          (x', y') -> ((x+.x')/.2. , (y +. y')/.2.);;
let  iso_barycentre a b c a' b' c'=
  let (x,y)= centre_de_gravite a b c in
  let (x',y') = centre_de_gravite a' b' c' in
    ((x+.x')/.2. , (y +. y')/.2.);;
iso_barycentre (1.,1.) (2.,2.) (3.,3.) (0.,0.) (1.,1.) (-1., -1.);;

(* Synonymes *)

type pair_liste = (int list)*(int list);;
type 'a pair_liste = ('a list)*('a list);;

(* Exemples *)

type 'a tree = Tr of 'a*'a tree list;;
let my_tree = (Tr(7,
               [Tr (2, [Tr (3, []); Tr (4, []); Tr (5, [])]);
                Tr (6, [Tr (7, []); Tr (8, [])]); 
                Tr (8, [])]));;
let max x y = if x>=y then x else y;;
let rec ajouter x = function 
    [] -> [x] 
  | (y::oths) -> 
      if x = y then x::oths else 
        y::(ajouter x oths);;
let rec union ens1 ens2 = match ens1 with
    [] -> ens2 
  | (x::autres) -> ajouter x (union autres ens2);;
open List;;
let rec size   = fun (Tr(r,l)) -> 
     1+ fold_left (fun s t -> s + (size t)) 0 l;;
let rec height = fun (Tr(r,l)) -> 
     1+ fold_left (fun h t -> max h (height t)) 0 l;;
let rec list_of_tree = fun (Tr(r,l)) -> 
     r::fold_left(fun l t ->(append l (list_of_tree t))) [] l;;
let rec set_of_tree = fun (Tr(r,l)) -> 
     union [r]  (fold_left (fun l t ->  union l (set_of_tree t)) [] l);;
size my_tree;;
height my_tree;;
list_of_tree my_tree;;
set_of_tree my_tree;;
let rec fold_tree  f g a = 
  fun (Tr(r,l)) ->
    let recur y = fold_tree f g a y in 
      f r (fold_left (fun x y -> g x (recur y)) a l);;
let size = fold_tree (fun r s -> 1+s) (fun x y -> x + y) 0;;
let height = fold_tree (fun r h -> 1+h) max 0;;
let list_of_tree = fold_tree (fun r l ->  r::l) append [];;
let set_of_tree = fold_tree (fun r l -> union [r] l) union [];;
height my_tree;;
size my_tree;;
list_of_tree my_tree;;
set_of_tree my_tree;;

(** Smantique oprationnelle **)

let Pi = 3.14;;
let r = 2.1;;
let s = Pi*.r*.r;;
2. *. s;;
a;;
let Pi = 3.1416;;
Pi;;
let x = 0;;
let x = 3 and y = x+1;;
let x = 10 in x+1;;
let x=x+1 and y=x+2 in x+y;;
x;;
y;;
let x = x+1 in let y = x+2 in x+y;;

(* valuation des fonctions. Fermetures. Liaison statique *)

let v = 2;;
let f = fun x -> if v > 3*2 then x+3 else x*x*3 + v;;
let v = 2;;
let f = fun x -> if v > 3*2 then x+3 else x*x*3 + v;;
let v = 100;;

(* valuation des applications : appel par valeur. *)

f (2*v);;

(* valuation des applications : appel par nom. *)


(* valuation des fonctions rcursives *)

