(** Exceptions **)


(* Le type exn *)

Division_by_zero;;
Failure "zut";;

(*  Gnration d'une exception *)

raise;;
let hd = function  [] -> raise (Failure "hd")
  |  (a::l)    -> a;;
hd [];;
1/0;;
1 + (raise (Failure "zut"));;
"hello"^ (raise (Failure "zut"));;
1 + (raise (Failure "zut"))^"hello";;
let failwith s = raise (Failure s);;
let hd = function  [] -> failwith "hd"
  | (a::l) -> a;;

(* Extension du type exn *)

exception Int_exception of int;;
let pred n = if n<=0 then (raise (Int_exception n))
                else n-1;;
pred 2;;
pred (-3);;

(* Rcupration d'une erreur *)

let f n = try (pred n) with (Int_exception 0) -> 0;;
f 3;;
f 0;;
f (-1);;

(** Entres/Sorties **)


(*  Fonctions de sorties *)

print_int;;
print_int 5;;
print_int (5+6*2);;
print_int (2/0);;
print_string;;
print_string "hello";;
print_string (string_of_float ((5.1+.8.2)/.3.));;
print_float ((5.1+.8.2)/.3.);;
print_newline;;
print_newline();;
print_char;;
print_char 'a';;
print_char '\n';;
print_string "\n Il y a dans les bois \n Des arbres fous d'oiseaux \n\n";;
print_endline;;
print_endline "\n Il y a dans les bois \n Des arbres fous d'oiseaux";;

(*  Fonctions de lecture *)

read_int;;
read_int();;
let x = read_int();;
let x = fact (read_int());;
read_int();;
read_float;;
read_float();;
read_float();;
read_float();;
read_line;;
let s = read_line();;

(**  Squencement **)

List.iter;;
let print_list = fun l -> (List.iter print_int l ; print_newline());;
print_list ([4;6;8]@[1;2]);;
(List.map print_int [1;2;3]);;
(List.map print_int [1;2;3]; print_newline());;
(List.iter print_int [1;2;3]; print_newline());;
let map_right f l  = List.fold_right (fun a l -> (f a)::l) l [];;
map_right print_int [1;2;3];;
let admission  = fun f ->      print_string "\nnote d'ecrit: ";
                                let e = read_float() in 
                                        (print_string "\nnote d'oral: ";
                                                let o = read_float() in 
                                                        (f e o));;
admission  (fun x y -> (x +. y)/.2.);;
let ponderation = (fun a b -> let r = (3.*.a+.b)/. 4. in 
                        print_string (if r<10. then "ajourne" else "admis");
                        print_newline();
                        print_newline());;
let resultat = admission ponderation;;
let resultat = fun () -> admission ponderation;;
resultat();;
resultat();;

(** Fichiers **)


(* Fichiers en criture *)

let c = open_out  "my_fic";;
output_string;;
output_string c "hello";;
output_string c "   bonjour!!!";;
close_out c;;
let c= open_out "my_fic";;
output_string c "je l'ignore  
";;
output_string c "maintenant je sais
 et je vais a la ligne";;
output_string c "\nfausse_fin";;
close_out c;;

(* Fichiers en lecture *)

let c=open_in "my_fic";;
input_char c ;;
input_char c;;
input_line c;;
input_line c;;
input_line c;;
input_line c;;
input_line c;;
let c=open_out "my_fic";;
close_out c;;

(** Structures de donnes modifiables **)


(* Les rfrences *)

let p= ref 0;;
!p;;
p:= !p+1;;
let incr ptr = ptr:= !ptr+1;;
!p;;
incr p;;
!p;;
let x=1;;
let f y = x+y;;
let x = 2;;
f 2;;                               
let x = ref 1;;            
let f y= !x + y;;          
f 2;;
x:= 2;;                   
f 2;;                     
let f = fun x -> incr x; (fun z -> z+1);;
let compteur= ref 0;;
let g y = f compteur y;; 
!compteur;;
g 3;;
g 2;;
g 10;;
!compteur;;
let g = f compteur;;
!compteur;;
g 0;;
g 1;;
g 2;;
!compteur;;

(* galit des valeurs et galit physique *)

let x=1.1;;
let y=1.1;;
x=y;;
x==y;;
let z=x;;
z==x;;
let z=x;;
let p1= ref 1;;
let p2 = ref 1;;
p1=p2;;         
p1==p2;;        
p1:= !p1 + 15;; 
p1;;            
p2;;            
let p3=p1;;
p3==p1;;
p1:=!p1+3;;
p1;;
p3;;
let id = fun ((x,y) as t )->t;;
let x = (1,1);;
x == id x;;
let id1 = fun (x,y)->(x,y);;
x == id1 x;;

(*  Vecteurs *)

[|0;1;2;3|];;
[|'a';'b';'c';'d'|];;
[|"vos";"yeux";"belle";"marquise"|];;
[|1;'a'|];;
[||];;
let v=[|1;2;3;4;5|];;
v.(0);;
v.(4);;
v.(10);;
[||].(0);;
let v=[|1;2;3;4;5|];;
v.(0)<- 10;;
v;;
Array.length;;
(Array.length [||]);;
Array.length [|1;2|];;
Array.map;;
Array.map (fun x->x+1) [|2;4;6;8|];;
Array.to_list;;
(Array.to_list [|1;2;3;4|]);;
Array.of_list;;
Array.of_list [1;2;3;4];;
let map_vect_list f vec = Array.to_list (Array.map f vec);;
map_vect_list (fun x -> x+1) [|2;4;6;8|];;
Array.iter;;
Array.iter print_int (Array.map (fun x->2*x) [|1;3;5;7|]);;
Array.iter (fun n -> (print_int(n);print_char(' ')))[|1;2;3|];;
let dichotomie comp e v = 
 let rec dicho d f =  if f<d then false
                       else
                         let m=(d+f)/2 in
                             if e=v.(m) then true
                             else
                                 if (comp e v.(m)) then (dicho  d (m-1))
                                            else (dicho  (m+1) f) 
 in dicho 0 (Array.length v -1) ;;
dichotomie (<=)  "yeux" [|"belle"; "d'amour"; "font"; "marquise"; "me"; "mourir"; 
                                "vos"; "yeux"|];;
dichotomie (<=) "mes"  [|"belle"; "d'amour"; "font"; "marquise"; "me"; "mourir"; 
                                "vos"; "yeux"|];;
let swap v i j =
    let l= (Array.length v)-1 in
        if (i>l) or (j>l) then (failwith "swap")
        else
           let x =v.(i) in
             (v.(i)<-v.(j);
              v.(j)<-x);;
let v =  [|1;2;3;4;5;6;7;8|];;
swap v 0 5;;
v;;

(* Enregistrements *)

type date = {mois:int;annee:int};;
let m={mois=1;annee=1952};;
m.mois;;
type individu= {nom:string;arrivee:date};;
let toto={nom="toto";arrivee={mois=1;annee=1952}};;
toto.arrivee.annee;;
let bissextile = fun {mois =_; annee=x} -> x mod 4 = 0;;
bissextile {mois=1;annee=1952};;
bissextile {mois=1;annee=1997};;
type coord = {mutable abs:float; mutable ord:float};;
type coord = {abs:float ref ; ord:float ref};;
let translation (a,b) pt = pt.abs <- pt.abs+.a; pt.ord <- pt.ord+.b;;
let point={abs=0. ; ord=3.};;
translation (1.,1.) point;;
point;;
let p1 = {abs= 2.; ord= 2.};;
let p2 = {abs= 2.; ord= 2.};;
let p3 = p1;;
translation (1.,1.) p1;;
p1;;
p2;;
p3;;

(** Exemples : les listes chanes circulaires **)

type 'a cellule={info:'a; mutable suiv:'a cellule};;
let rec toto = {info= 1; suiv=toto};;
let make_list e = let rec x={info=e;suiv=x} in x;;
#print_depth 10;;
let l= make_list "d'amour";;
let last l = l.info;;
let first l = l.suiv.info;;
let print_clist l = print_endline ((first l)^"..."^(last l));;
#install_printer print_clist;;
let insert l e = l.suiv <- {info=e;suiv=l.suiv};l;;
let l = insert l "mourir";;
last l;;
first l;;
let print_clist l =
  let rec print_clist_acc l beg  =
    if l.suiv == beg then print_endline (first l)
    else
      (print_string ((first l)^","); 
       print_clist_acc l.suiv beg)
  in
    print_clist_acc l l
;;
#install_printer print_clist;;


let l= insert l "font" in insert l "me";;
last l;;
first l;;
let l = insert l "yeux"; insert l "beaux";insert l "vos";;
first l;;
last l;;
let insert_tail l e = l.suiv <- {info=e;suiv=l.suiv}; l.suiv;;
let insert_tail l e = let x = {info=e;suiv=l.suiv} in
                      (l.suiv<- x;x);;
let l= insert_tail l "belle";;
first l;;
last l;;
let l = insert_tail l "marquise";;
first l;;
last l;;
let elim_head l = l.suiv <- l.suiv.suiv; l;;
elim_head l;;
let m = make_list 1;;
elim_head m;;
let l= let x= make_list "vos" in
fold_left insert_tail 
        x 
        ["beaux";"yeux";"me";"font";"mourir";"d'amour";"belle";"marquise"] ;;
let circ_list_of_list =   function []   -> failwith "circ_list_of_list"
                          | (a::l) ->let x= make_list a in
                                      (List.fold_left insert_tail x l);;
let q = circ_list_of_list ["vos";"beaux";"yeux";"me";"font";"mourir";"d'amour";
                                "belle";"marquise"] ;;
let list_of_circ_list l = 
     let rec l_of_c p = 
         if p==l then [] else 
            first p :: l_of_c p.suiv
     in
           (first l :: l_of_c l.suiv) ;;
list_of_circ_list q;;

(** Boucles **)

let liste i n = 
  let ls = ref [] in 
    for j = n downto i 
    do
      ls := j::!ls
    done ;
    !ls;;
liste 1 10;;
let until predicat changer x =
  let y = ref x in
    while not (predicat !y) 
    do
      y :=  changer(!y)
    done;
    !y;;
until (fun x -> x > 10) (fun x -> x+1) 0;;
let until predicat changer x =
  let y = ref x in
    while not (predicat !y) 
    do
      y :=  changer(!y) ; 1
    done;
    !y;;
let y = ref 0;;
y:= !y + 1; 1;;
