#!/usr/local/bin/bash
#!/bin/bash

# Ce script sert  copier soumettre votre projet  L.S.

function usage()
{
    echo Usage : $0  repertoire_avec_votre_projet_de_logique 
    exit -1
}

function sortir()
{
    echo "$1 : opration avorte." >&2
    exit -1
}


THISUSER=$(whoami)
if which finger 2>/dev/null 1>/dev/null; then
    AWKPROG='{ print $4 "_" $5 }'
    THISCOMPLETEUSER=`finger $THISUSER | head -1 | awk "$AWKPROG"`
elif
    [ -r /etc/passwd ]; then
    AWKPROG='{ print $5 }'
    THISCOMPLETEUSER=`grep $THISUSER /etc/passwd | awk -F: "$AWKPROG"`
else
    THISCOMPLETEUSER=$THISUSER
fi

HOST="`uname -n`"
if [ "$HOST" = "localhost" ]; then
    DESTDIR="/home/lsantoca/logique/projets/"
else
    if [ "$HOST" != "daumier" ]; then
	echo "On vous logge sur daumier" 
	ssh "$THISUSER@daumier" "cd $PWD; $0 $*" 
	exit 0
    fi
    DESTDIR="/home/santocan/logique/projets/"
fi

AWKPROG='{ print $4 }'
TARVERSION=`tar --version | head -1 | awk "$AWKPROG"`
if [ "$TARVERSION" != "1.13.25" ]; then
    echo "On a besoin de la version de tar 1.13.25."
    sortir "Essayer ce mme script a partir de la machine massilia (ssh,telnet massilia)."
fi

BASEDIR=`basename $1`
LOGFILE="${0/.sh/}"\_"$BASEDIR.log"

POSTFIX=projet
OUTNAME="$THISUSER"\_"$POSTFIX"
OUTFILE="$DESTDIR$OUTNAME.tar"

[ "$#" = "1" ] ||  usage 
[ "$1" = "-h"  -o  "$1" = "--help" ] && usage
#[ $PWD = $1 ] && sortir ..
[ -d $1 ] || sortir "Le ficher $1 n'est pas un rpertoire ou il n'existe pas"
[ -d $DESTDIR ] || sortir "Le rpertoire $DESTDIR n'existe pas"
ls $1/*.c 1> /dev/null 2>/dev/null || sortir "On ne trouve pas de fichier .c dans le repertoire $1"
[ -w $DESTDIR ] || sortir "Le rpertoire $DESTDIR n'est pas accessible en criture"
[ -e $LOGFILE ] && FIC=`basename $LOGFILE` && sortir "Un fichier  $FIC existe dj"
[ -e $OUTFILE ] && FIC=`basename $OUTFILE` && sortir "Il'existe dj un fichier $FIC dans $DESTDIR"
[ -e $OUTFILE.gz ] && FIC=`basename $OUTFILE.gz` && sortir "Il'existe dj un fichier $FIC dans $DESTDIR"

tar -cf "$OUTFILE" -C $1 ./ || sortir "Problme avec tar"
echo "Fichiers envoyes :" | tee -a $LOGFILE
(tar -tf "$OUTFILE" | tee -a $LOGFILE)  || sortir "Problme avec tar"
echo "$THISCOMPLETEUSER, $THISUSER, `date`" > $DESTDIR$THISUSER.date
tar -C $DESTDIR -rf $OUTFILE ./$THISUSER.date
rm $DESTDIR$THISUSER.date
echo
gzip $OUTFILE || sortir "Problme avec gzip"

# Prochaine ligne necessaire sinon je ne peux pas lire le fichier
chmod 606 "$OUTFILE.gz"

echo "Programme termin normalement le `date`." | tee -a $LOGFILE

exit 0
