(* Types de donnes *)
type ('a,'b,'c) atomic_formula
type ('a,'b,'c) clause
type ('a,'b,'c) theorie = ('a,'b,'c) clause list

(* Formules atomiques *)
val atf_faire : 'a -> ('b, 'c) Terme.t list -> ('a, 'b, 'c) atomic_formula 
val atf_to_string : (string, string, string) atomic_formula -> string 
val atf_print : (string, string, string) atomic_formula -> unit 
val atf_parse : 
  (Genlex.token Stream.t) -> 
  (string,string,string) atomic_formula
val atf_of_string : string ->
  (string, string, string) atomic_formula 

(* Clauses *)
val faire :
  ('a, 'b, 'c) atomic_formula list ->
  ('a, 'b, 'c) atomic_formula list -> ('a, 'b, 'c) clause 
val gauche :
  ('a, 'b, 'c) clause 
  ->  ('a, 'b, 'c) atomic_formula list 
val droite :
  ('a, 'b, 'c) clause 
  ->  ('a, 'b, 'c) atomic_formula list 


val to_string : (string, string, string) clause -> string 
val print : (string, string, string) clause -> unit 
val parse : 
  (Genlex.token Stream.t) -> 
  (string,string,string) clause
val of_string : string ->
  (string, string, string) clause

(* Thories *)
val theorie_faire : ('a,'b, 'c) clause list -> ('a, 'b, 'c) theorie 
val theorie_to_string : (string, string, string) theorie -> string 
val theorie_print : (string, string, string) theorie -> unit 
val theorie_parse : 
  (Genlex.token Stream.t) -> 
  (string,string,string) theorie
val theorie_of_string : string ->
  (string, string, string) theorie 

(* Quelques fonctions *)
val vide : ('a,'b,'c) clause
val length : ('a,'b,'c) clause -> int*int
val remove : 
  int ->
  ('a,'b,'c) atomic_formula list ->
  ('a,'b,'c) atomic_formula list
val apply : ('b,'c) Terme.subst -> ('a,'b,'c) atomic_formula -> ('a,'b,'c) atomic_formula
val apply_to_clause : ('b,'c) Terme.subst -> ('a,'b,'c) clause -> ('a,'b,'c) clause
val unify : ('a,'b,'c) atomic_formula *('a,'b,'c) atomic_formula -> ('b,'c) Terme.subst


(* Prdicats pour la simplification *)
val taut : ('a, 'b, 'c) clause -> bool
val sous : ('a, 'b, 'c) clause -> ('a, 'b, 'c) clause -> bool
