let nameprog = "Resolution pour la logique du premier ordre";;
let version = "0.2";;
let author = "Luigi Santocanale";;

let file_eval() = 
  print_newline();
  print_string "Rentrez le nom du fichier : ";  
  let 
    theorie = Io.read_theorie (read_line()) 
  in
    Io.pretty_eval theorie
;;


let interact_eval() = 
  let
    theorie = ref []
  in
    try
      while true do
	print_newline();
	print_string "Rentrez une clause : ";
	let 
	  newclause = Clause.of_string(read_line())
	in
	  theorie := newclause::!theorie; 
      done
    with
	_ ->
	  Io.pretty_eval !theorie
;;

let infosyntaxe() =
  print_newline();
  print_endline "Un terme est ou bien une variable" ;
  print_endline "\tx";
  print_endline "ou bien il a la forme" ;
  print_endline "\tf(t1,...,tn)";
  print_endline "o les ti sont des autres termes.";
  print_newline();
  print_endline "Une formule atomique est de la forme" ;
  print_endline "\tP(t1,...,tn)";
  print_endline "o les ti sont des termes.";
  print_newline();
  print_endline "Une clause est de la forme :";
  print_endline "\t g1,...gm => d1,...,dm";
  print_endline "o les gi et les dj sont des formules atomiques.";
  print_newline();
  print_endline "Une theorie est une liste de clauses.";
  print_endline "On la crive sous la forme :";
  print_endline "\t{c1;...;cm}";
  print_endline "o les ci sont des clauses.";
(*
  print_newline();
  print_endline "Exemple :";
  print_endline "\tHumain implique Animal";
  print_endline "devient";
  print_endline "\t{{~Humain,Animal}}";
*)
  print_newline()
;;
   
let quit() = 
  print_endline "Merci et A+";
  exit(0) 
;;

    
let main() = 
  print_endline nameprog ;
  print_endline ("Version no : "^version) ;
  print_endline author ;
  print_newline();
  print_endline ("Derniere mise  jour : "^Miseajour.miseajour) ;
  print_newline();
  
  match Array.length Sys.argv with
      1 ->
	Menus.menu [
	  ("Saturer une thorie (interactif)",interact_eval);
	  ("Saturer une thorie ( partir d'un fichier)",file_eval);
	  ("Info syntaxe",infosyntaxe);
	  ("Quitter",quit)
	] 
   | 2 ->
	let theorie = Io.read_theorie Sys.argv.(1) in
	  Io.pretty_eval theorie
    | 3 ->
	let 
	  theorie = Io.read_theorie Sys.argv.(1)
	and
	  clause = Clause.of_string Sys.argv.(2)
	in
	  Io.pretty_eval (clause::theorie)
    | _ -> quit()
;;

main();;
