#!/bin/bash

COMPILE="gcc -Wall -pedantic"

function pause()
{
    echo -ne $1
    read PAUSE
}

function new_ex(){
    echo; echo "Exercice $1, $2 points (Tapez quelque chose) :"
    pause
}

function do_command(){
    echo -e "% $1"
    sh -c "$1"
}

function do_compile(){
    pause "Compilation de $1 (Tapez quelque chose) :"
    do_command "$COMPILE  $1 -o ${1/.c/}"
}

function do_show(){
    pause "\nProgramme $1 (Tapez quelque chose, q pour terminer less) :"
    awk '{printf "%2d : %s\n", NR, $0}' $1 | less
}

function do_progr(){
    
    do_show $1

    do_compile $1

    pause "\nExecution de $1 (Tapez quelque chose) :"
    do_command "${1/.c/}"
}

rm -f a.out
FICS=`ls *.[ch]`
for fic in $FICS;
  do
  rm -f ${fic/.c/}
done

echo; echo Le langage C

new_ex 1.a 1
do_progr tab-pointer.c

new_ex 1.b 1
do_progr tab-pointer2.c

new_ex 2 3
do_progr palindrome.c

new_ex 3 2
do_progr operateurs.c

echo; echo Programmation systme

new_ex 4.a 1 
echo "Ou bien :" 
do_command "ls *.[ch] | wc -l"
echo "ou alors :" 
do_command "ls | grep -c \.[ch]$"

new_ex 4.b 2
echo "Exemple, ce programme n'est pas correcte :"
do_progr "lswcl.c"
echo "Par contre, ce programme est bien correcte :"
do_progr "lswcl2.c"

new_ex 5.a 1

echo "J'ai modifi le programme de l'enonc" 
echo "afin de verifier l'arbre genealogique"
echo " l'aide de la commande ps :" 
PROG="forkand"
do_show $PROG.c
COMMAND="$COMPILE -DOPERATION=\"&&\" $PROG.c -o $PROG"
do_command "$COMMAND"
COMMAND="$PROG& sleep 1; ps -C $PROG  f -o \"%p%P%c\"; killall $PROG"
do_command "$COMMAND"


new_ex 5.b 1
echo; echo "Le meme programme avec *  la place de && :"
PROG="forkand"
so_show $PROG
COMMAND="$COMPILE -DOPERATION=\"*\" $PROG.c -o $PROG"
do_command "$COMMAND"
COMMAND="$PROG& sleep 1; ps -C $PROG  f -o \"%p%P%c\"; killall $PROG"
do_command "$COMMAND"


new_ex 6 2
PROG="forkbasic"
do_show $PROG.c
do_compile $PROG.c
COMMAND="$PROG& sleep 1; ps -C $PROG  f -o \"%p%P%c\"; killall $PROG"
do_command "$COMMAND"

new_ex 7.a 1.5 
PROG="append"
do_show $PROG.c
do_compile $PROG.c
COMMAND="echo aaa > a.txt ; echo bbb > b.txt"
do_command "$COMMAND"
do_command "cat a.txt; cat b.txt"
do_command "$PROG a.txt b.txt"
do_command "cat b.txt"

new_ex 7.b 0.5
do_command "cat a.txt >> b.txt"
do_command "cat b.txt"
do_command "rm -f a.txt b.txt"

new_ex 8.a 0.5
PROG=suivant
do_show $PROG.c
do_compile $PROG.c
do_command "echo 0 1 | suivant"

new_ex  8.b 0.5
do_command "echo 0 1 | suivant | suivant | suivant "


new_ex 8.c 1
PROG="niemefibo.sh"
do_show $PROG
echo "Rentres un nombre: "
read n
do_command "./$PROG $n"

new_ex 9 3
PROG="fibo2"
do_show $PROG.c
do_compile $PROG.c
do_command "$PROG 0 1 & sleep 1; killall -s 2 $PROG"

new_ex 10 1.5
do_progr sanslecteur.c


new_ex 11 1.5
PROGR=forkwait
do_show $PROGR.c
do_compile $PROGR.c
i=1
while [[ $i -le 10 ]] ; 
  do 
  echo -e "\n$i-eme lancement de $PROGR :"
  $PROGR
  i=$(( $i + 1 ))
done

