#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>



unsigned long p,q;

void interruption(int signum)
{
  printf("%lu\n",p);
  exit(EXIT_SUCCESS);
}

void init_fibo(int in_fic,int out_fic)
{
  write(out_fic,&p,sizeof(unsigned long));
  write(out_fic,&q,sizeof(unsigned long));
}

void iter_fibo(int in_fic,int out_fic)
{
  unsigned long somme;

  do{
    /*  Sortir par ici,  */
    /*  si le tube n'est pas ouverte en lecture par personne */
    if(read(in_fic,&p,sizeof(unsigned long)) == 0)
      exit(EXIT_SUCCESS);
    read(in_fic,&q,sizeof(unsigned long));
    somme = p+q;
    
    write(out_fic,&q,sizeof(unsigned long));
    write(out_fic,&somme,sizeof(unsigned long));
  }while(1);
  
}

int main(int argc, char *argv[])
{
  int pf[2],fp[2];
  
  if(! 
     (argc == 3 
      && 
      sscanf(argv[1],"%lu",&p) == 1
      && 
      sscanf(argv[2],"%lu",&q) == 1 )
     )
    {
      printf("%s : arguments invalides\n",argv[0]);
      exit(EXIT_FAILURE);
    }

  pipe(pf);pipe(fp);
  
  if(fork())
    {
      signal(SIGINT,interruption);
      close(pf[0]);close(fp[1]);
      init_fibo(fp[0],pf[1]);
      iter_fibo(fp[0],pf[1]);
    }
  else
    {
      close(pf[1]);close(fp[0]);
      iter_fibo(pf[0],fp[1]);
    }
  
  /* On ne revient pas !!!*/
  exit(EXIT_FAILURE);

}

