#include <stdlib.h>
#include <stdio.h>
#include "arriere.h"
#include <string.h>


const char *signature = "\n/*No lu : %d */";

int reverse (char *chaine);
void mettre_ajour_sig (FILE * flot);
void imprimer (FILE * flot);

int
main (int argc, char *argv[])
{
  FILE *flot;

  /*  Nombre insuffisant d'arguments */
  if (argc <= 1)
    return EXIT_FAILURE;

  /*  Ouvrir flot  la fin */
  flot = fopen (argv[1], "r+");
  if (flot == NULL)
    return EXIT_FAILURE;

  mettre_ajour_sig (flot);
  imprimer (flot);

  fclose (flot);
  return EXIT_SUCCESS;
}

void
mettre_ajour_sig (FILE * flot)
{
  int no_fois_lu = 0;
  char buffer[1024];

  /* Se placer a la fin du fichier */
  fseek (flot, 0, SEEK_END);

  /*  
     Lire la derniere ligne :
     si celle n'existe pas 
     nous ajoutons la signature au fichier 
   */
  if (arriere_fgets (buffer, sizeof (buffer), flot) == NULL)
    {
      fprintf (flot, signature, 1);
      return;
    }

  /* Renverser le buffer */
  reverse (buffer);

  /* 
     Si la dernire ligne n'est pas une signature
     ajouter la signature  la fin du fichier
   */
  if (sscanf (buffer, signature, &no_fois_lu) != 1)
    {
      fseek (flot, 0, SEEK_END);
      fprintf (flot, signature, 1);
    }
  /* sinon, rcrire la dernire ligne  */
  else
    {
      fprintf (flot, signature, no_fois_lu + 1);
    }

}

void
imprimer (FILE * flot)
{
  char buffer[1024];

  fseek (flot, 0, SEEK_SET);
  while (fgets (buffer, sizeof (buffer), flot) != NULL)
    puts (buffer);
}

int
reverse (char *chaine)
{
  int longeur, demilongeur, i;
  char c;

  longeur = strlen (chaine);
  demilongeur = longeur / 2;

  for (i = 0; i < demilongeur; i++)
    {
      c = chaine[i];
      chaine[i] = chaine[longeur - i - 1];
      chaine[longeur - i - 1] = c;
    }

  return longeur;

}
