#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h> 
#include <sys/fcntl.h>
#include <sys/stat.h>

#include "monreadwrite.h"
#include "monsleepwakeup.h"


#define NB_CASES 10
#define MAXDELAI 3
int compteur=NB_CASES;

void producteur(int cons_pid,char *nomfic)
{
  int pid=getpid();
  srand(pid*time(NULL));
  while(1){
    sleep(rand()%MAXDELAI);
    compteur= mon_read(nomfic);
    if(compteur == NB_CASES)
      mon_sleep();
    else
      {
	compteur++;
	mon_write(nomfic,&compteur);
      }
    
    if(compteur == 1)
      mon_wakeup(cons_pid);
    printf("[%d] Nombre d'objets produits : %d.\n",
           pid,compteur);
  }
}

void consommateur(int prod_pid,char *nomfic)
{
  int pid=getpid();
  srand(pid*time(NULL));  
  while(1){
    sleep(rand()%MAXDELAI);
    compteur = mon_read(nomfic);
    
    if(compteur == 0)
      mon_sleep();
    else
      {
	compteur--;
	mon_write(nomfic,&compteur);
      }
    
    if(compteur == NB_CASES -1)
      mon_wakeup(prod_pid);
    printf("[%d] Nombre d'objets  consommer : %d.\n",
           pid,compteur);
  }
}

int main(void)
{
  pid_t pid;
    
  init_sleepwakeup();

  mon_write("compteur",&compteur);
  switch(pid = fork())
    {
    case -1:
      exit(EXIT_FAILURE);
    case 0:
      producteur(getppid(),"compteur");
    default:
      consommateur(pid,"compteur");
    }
  exit(EXIT_FAILURE);
}


