#include "semaphores.h"

#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>

#define LOCKDIR "/tmp/"
#define MAXTRIES  3
#define NAPTIME 1
#define TAILLE_CHEMIN 1024

/* Par dfaut une fonction est globale au programme */
/* Pour rendre locale la fonction lockpath  ce module */
/* (donc, pour la cacher aux autres modules) */
/* il faut utiliser le mot-cl static */

static char *lockpath(char *);

int lock(char *name)
{
  char *path=lockpath(name);
  int fd,essays=0;
  extern int errno;
  
  while( (fd = creat(path,0)) == -1 && errno == EACCES )
    {
      if( ++essays >= MAXTRIES)
        return 0;
      sleep(NAPTIME);
    }
  if( fd == -1 || close(fd) == -1 )
    perror("lock");
  return(1);
}

void unlock(char *name)
{
  if(unlink(lockpath(name)) ==  -1)
    perror("unlock");
}

static char *lockpath(char *name)
{
  static char path[TAILLE_CHEMIN];
    
  strncpy(path,LOCKDIR,TAILLE_CHEMIN);
  return(strcat(path,name));
}
