/* Exercice no. 3 */ 

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <string.h>
#include "authorisation.h"

int 
authorisation(char *chemin, int mode)
{
  int i,ret;
  int n = strlen(chemin);
  char *path=malloc(n + 1);
  
  for(i=0;i < n ;i++)
    {
      if( chemin[i] == '/' || i == n - 1 )
	{
	  strncpy(path,chemin,i+1);
	  if( i == n-1 )
	    ret = loc_author(path,mode);
	  else
	    ret = loc_author(path,EXEC);

	  switch(ret){
	  case NONACCESSIBLE:
	    free(path);
	    return NONACCESSIBLE;
	  case CODEERREUR:
	    free(path);
	    return CODEERREUR;
	  default:
	  case ACCESSIBLE:
	    break;
	  }
	}
    }

  free(path);
  return ACCESSIBLE;
}

int 
loc_author(char *chemin, int mode)
{
  uid_t uid=getuid(),gid=getuid();
  char errmess[TAILLEERRBUF];

  struct stat statbuf;
  
  if(stat(chemin,&statbuf) == -1 )
    {
      snprintf(errmess,TAILLEERRBUF,"stat sur fichier %s", chemin);
      perror(errmess);
      return CODEERREUR; 
    }

  if(statbuf.st_uid==uid)
    mode = mode << 6;
  else if (statbuf.st_gid==gid)
    mode = mode <<3;
 
  if( statbuf.st_mode & mode )
    return ACCESSIBLE;
  else
    return NONACCESSIBLE;
}
