/* Exercice no. 1 : identique.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>

static char * chemin1, *chemin2;
static int (*cestat)(const char *, struct stat *);

static void setoptions(int argc,char *argv[]); 
static void usage(char *);

int
main(int argc, char *argv[])
{
  struct stat statbuf_1, statbuf_2;

  setoptions(argc,argv);

  if( cestat(chemin1,&statbuf_1) == -1
      ||
      cestat(chemin2,&statbuf_2) == -1 )
    {
      perror(argv[0]);
      usage(argv[0]);
    }

  if(
     statbuf_1.st_dev == statbuf_2.st_dev 
     &&
     statbuf_1.st_ino == statbuf_2.st_ino
     )
    printf("Priphrique no. %d, i-noeud no. %d.\n"
	   "Les chemins %s et %s rfrencent le mme fichier.\n",
	   (int)statbuf_1.st_dev, (int)statbuf_1.st_ino,
	   chemin1,chemin2);
  else
    {
      printf("Chemin %s :\n"
	     "priphrique no. %d, i-noeud no. %d.\n"
	     "Chemin %s :\n"
	     "priphrique no. %d, i-noeud no. %d.\n",
	     chemin1, (int)statbuf_1.st_dev, (int)statbuf_1.st_ino,
	     chemin2, (int)statbuf_2.st_dev, (int)statbuf_2.st_ino);
      printf("Les deux chemins ne rfrencent pas le mme fichier.\n");
    }
  
  return EXIT_SUCCESS;
}

static void setoptions(int argc, char * argv[])
{
  if( argc < 3)
    usage(argv[0]);

  if(strcmp(argv[1],"-L") == 0)
    {
      /* Si on NE veut PAS suivre les liens symboliques */
      /* il faut utiliser lstat. */
      cestat=lstat;
      chemin1=argv[2];
      chemin2=argv[3];
    }
  else
    {
      /* Si on veut suivre les liens symboliques */
      /* il faut utiliser lstat. */
      cestat=stat;
      chemin1=argv[1];
      chemin2=argv[2];
    }
}

static void usage(char *s)
{
  fprintf(stderr,"\nUsage : %s [-L] chemin1 chemin2\n",s);
  exit(EXIT_FAILURE);
}
