#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <time.h>
#include <sys/types.h> 
#include <unistd.h>

int rev_heure,rev_minutes;

void interruption(int signum)
{
  FILE * flot;
  int heure,minutes;
 
  if((flot = popen("date +%Hh%M","r")) == NULL)
    {
      perror("popen");
      exit(EXIT_FAILURE);
    }
  fscanf(flot,"%2dh%2d",&heure,&minutes);  
    
  printf("\n%2dh%2d\n",heure,minutes);
  if(heure == rev_heure  && minutes == rev_minutes)
    {
      printf("Dring!\n");
      exit(EXIT_SUCCESS);
    }
  alarm(60);
}

void usage(char *nomcommande)
{
  printf("Usage : %s nnhmm\n"
	 "(nn=heures, mm=minutes)\n",nomcommande);
  exit(EXIT_FAILURE);
}

int main(int argc, char *argv[])
{
  
  struct sigaction action;

  if(argc != 2 || 
     sscanf(argv[1],"%2dh%2d",&rev_heure,&rev_minutes) != 2)
    usage(argv[0]);
  
  action.sa_handler=interruption;
  action.sa_flags=0;
  sigemptyset(&action.sa_mask);
  sigaction(SIGALRM,&action,NULL);
  
  alarm(60);
  for(;;) pause();

  return EXIT_SUCCESS;
}
