(*****************************************************************************)
(*****  	   Arbres Lexicaux  			             *****)
(*****                                                                   *****)
(***** Master info 1ere anne 							 *****)
(***** Prade Jean-Philippe                                               *****)
(*****************************************************************************)

(** Remarques par Luigi Santocanale : **)
(** Code pour adapt  Ocaml par LS   **)
(** tres bon code, j'ai substitu     **)
(**     begin ... end                 **)
(** par                               **)
(**         ( ... )                   **)
(** afin de mettre en evidence qu'on  **)
(** est encore en style fonctionnel   **) 

(* la structure de donne *)
type lex_noeud = Letter of char * bool * lex_arbre
and
  lex_arbre = lex_noeud list;;
type mot = char list;;

(* un arbre lexical *)
let monArbre = [Letter('c',false,
			[Letter('a',false,
				[Letter('s',true,
					[Letter('s',false,
						[Letter('e',true,[])]
					)]
				)]
			);
			Letter('h',false,
				[Letter('a',false,
					[Letter('t',true,[])]
				);
				Letter('e',false,
					[Letter('r',true,[])]
				)]
			)]
			
		);
		Letter('d',false,
			[Letter('e',true,[])]
		)];;

 
(* extension de type *)
type 'a option = None | Some of 'a;;

(* cherche la lettre c sur la liste des racines *)
let rec trouver arbre c=
	match arbre with
	[] -> None
	|(Letter(y,b,l))::q -> if c=y then Some( Letter(y,b,l))
				else trouver q c;;


(* rechercher un mot m dans l'arbre *)
let rec exists m arbre =
  match m with 
      [] -> if arbre = [] then false else true
    | [a] ->  
	(
	  match (trouver arbre a) with
	      None -> false
	   | Some( Letter(c,b,l) ) -> b
	)
    | t::q -> 
	(
	  match (trouver arbre t) with 
	      None -> false
	    | Some( Letter(c,b,l) )-> exists q l 
	);;

(* tests *)
exists ['c'; 'a'; 's'] monArbre;; 		(* true *)
exists ['c'; 'a'; 's'; 's'; 'e'] monArbre;;	(* true *)
exists ['c'; 'h'; 'a'; 't'] monArbre;;		(* true *)
exists ['c'; 'h'; 'e'; 'r'] monArbre;;		(* true *)
exists ['d'; 'e'] monArbre;;			(* true *)
exists ['n'; 'o'; 'n'] monArbre;;		(* false *)
exists ['f'; 'a'; 'l'; 's'; 'e'] monArbre;;	(* false *)

(* insere un mot sans respecter l'ordre alphabetique *)
let rec insert m arbre = 
  match m with
      [] -> arbre
    | t::q -> 
	( 
	  match arbre with
	      [] ->[Letter (t,q=[],insert q [])]
	    | (Letter(y,b,l))::rest ->
		if t=y then 
		  if q=[] then 
		    (Letter(y,true,l))::rest
		  else 
		    (Letter(y,b,(insert q l))::rest)
		else
		  (Letter(y,b,l))::(insert m rest) 
	);;
					
(* test *)			
let monArbre=insert ['c'; 'h'; 'e'; 'r';'c'; 'h'; 'e'] monArbre;;
let monArbre=insert ['d'; 'e'; 's'; 's';'i'; 'n'] monArbre;;
let monArbre = insert ['d'; 'e'; 's'; 's';'e'; 'i';'n'] monArbre;;

(* construit un arbre  partir d'une liste de mot *)
let construire mot_liste=
	let rec cons_rec mot_liste arbre=
		match mot_liste with
		[]->arbre
		|t::q -> cons_rec q (insert t arbre)
	in cons_rec mot_liste [] ;;

(* 	transforme une string en mot ::
	"salut" en ['s'; 'a'; 'l'; 'u'; 't'] *)		
let rec s_to_c_list chaine =
	if (String.length chaine)=0 then []
	else
	chaine.[0]::(s_to_c_list (String.sub chaine 1 ((String.length chaine)-1)));;

(* transforme une liste de string en liste de mot *)
(** LS : On peut aussi definir cette fonction comme **)
(** List.map s_to_c_list chaine_ls **)

let rec s_list_to_c_list chaine_ls=
	match chaine_ls with 
	[]->[]
	|t::q -> s_to_c_list(t)::s_list_to_c_list(q);;

(* test *)
let unArbre = construire (s_list_to_c_list ["bravo";"brasse";"bresil";"base";"balle";"jour";"jouer"]);;

