/* Exercice 5, deuxieme version */  

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <time.h>

#define NB_FILS 3
#define NB_ENVOIS 10
#define ACK SIGUSR2 
  
void interruption(int signum)
{
  static int nb_fois=0;
  
  switch(signum)
    {
    case SIGUSR1:
      nb_fois++;
      printf("[4%d] J'ai reu %d signaux\n",getpid(),nb_fois);
      kill(getppid(),ACK);
      printf("%d <- %d (ACK)\n",getppid(),getpid());
      break;
    case SIGALRM:
      exit(nb_fois);
    case ACK:
      break;
    }
}

void filio(void)
{
  for(;;);
}

void padre(pid_t fils[])
{
  int i,j;
  int status, pid;
  
  srand(time(NULL));
  printf("Envoie des messages :\n");

/*   sleep(1); */
  for(i=0;i< NB_ENVOIS;i++)
    {
      j = rand()%3;
      printf("%d -> %d (SND)\n",getpid(),fils[j]);
      kill(fils[j],SIGUSR1);
      pause(); 
    }

  
  for(i=0;i<NB_FILS;i++)
    {
      kill(fils[i],SIGALRM);
      pid = wait(&status);
      if(WIFEXITED(status)) 
      printf("\n[%d] : le <<score>> du fils %d est %d\n", 
	     getpid(),pid,WEXITSTATUS(status));
    }
}

int main(void)
{
  int i;
  pid_t fils[NB_FILS],fpid;
  struct sigaction action;

  /* Initialisation de l'handler */
  action.sa_handler=interruption;
  sigemptyset(&action.sa_mask);
  /* sigaddset(&action.sa_mask,SIGUSR1); */
  action.sa_flags=0;
  sigaction(SIGUSR1,&action,NULL);
  sigemptyset(&action.sa_mask);
  sigaction(ACK,&action,NULL);
  sigaction(SIGALRM,&action,NULL);
   
  for(i=0;i< NB_FILS;i++)
    {
      switch(fpid = fork())
	{
	case -1:
	  exit(EXIT_FAILURE);
	case 0:
	  filio();
	  /* On ne revient pas !!! */
	default:
	  fils[i]=fpid;
	}
    }
  padre(fils);
  exit(EXIT_SUCCESS);
}
