/* Exercice no 3 */

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <signal.h>
#include <time.h>

#define NB_FILS 3
#define UNSIGNAL SIGUSR1
/* #define UNSIGNAL SIGCHLD */

static int fils_ayant_termine=0;

void interruption(int signum)
{
  if(signum == UNSIGNAL)
    {
      printf("[%4d] dit : un des fils a termin\n", getpid());
      fils_ayant_termine++;
    }
}

void filio(void)
{
  srand(getpid()*time(NULL));
  sleep(rand() % 3);
  printf("[%4d] dit : j'ai fini!\n", getpid());
  kill(getppid(),UNSIGNAL); 
  exit(EXIT_SUCCESS);
}

int main(void)
{
  int i;
  struct sigaction action;

  /* Initialisation de l'handler */
  action.sa_handler=interruption;
  sigemptyset(&action.sa_mask);
  sigaddset(&action.sa_mask,UNSIGNAL); 
  action.sa_flags=0;
  sigaction(UNSIGNAL,&action,NULL);
  
  for(i = 0; i< NB_FILS; i++)
    {
      switch(fork()){
      case 0 :
	filio();
      case -1 :
	exit(EXIT_FAILURE);
      default :
	;
      }
    }

  while(fils_ayant_termine != NB_FILS)
    pause();

  printf("Fin.\n");
  exit(EXIT_SUCCESS);
}
