/* tubonacci.c */

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/wait.h>

#define TYPE char
#define SIZE sizeof(TYPE)

int main(void)
{
  int tube_pf[2];
  int tube_fp[2];
  int pid;
  
  unsigned TYPE p,q;

  pipe(tube_pf); /* Tube pere -> fils */
  pipe(tube_fp); /* Tube fils -> pere */

  if( (pid=fork()) == -1)
    exit(EXIT_FAILURE);

  if(pid > 0) /* pere */
    {
      close(tube_pf[0]);
      close(tube_fp[1]);
      
      p = 3;
      write(tube_pf[1], &p,SIZE);
     
      p = 2;
      while(p <= 200)
	{
	  printf("%d\n",p);
	 
	  write(tube_pf[1],&p,SIZE);
	  read(tube_fp[0],&p,SIZE);
	 
	}
      close(tube_pf[1]);
      wait(NULL);
    }
  else /* fils */
    {
      close(tube_pf[1]);
      close(tube_fp[0]);
      
      read(tube_pf[0],&p,SIZE);
      while(read(tube_pf[0],&q,SIZE) == 1)
	{
	  write(tube_fp[1],&p,SIZE);
	  p = 3*q + 2*p;
	}
    }
  
  
  printf("[%d] : terminaison\n", getpid());
  exit(EXIT_SUCCESS);    
}
