#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>

#define ENTREE 0
#define SORTIE 1

int main(int argc, char *argv[])
{
  int  tube[2];
  int calu;

  pipe(tube);
  if( fork() ) /* Le pre : filtre */
    {
      /* Redirige STDIN sur l'entre du tube */
      close(STDIN_FILENO);
      dup(tube[ENTREE]); 
      close(tube[ENTREE]);
      close(tube[SORTIE]);
     
      while( (calu = getchar()) != EOF )
	{
	  if ( calu >= 'a' && calu <= 'z')
	    calu -= 'a' - 'A'; /* mettre les majuscules */
	  printf("%c",calu);
	}
      fflush(stdout);
      close(STDOUT_FILENO);
      wait(NULL);
    }
  else /* Le fils : excute la commande */
    {      
      /* Redirige STDOUT sur la sortie du tube */
      close(STDOUT_FILENO);
      dup(tube[SORTIE]);
      close(tube[ENTREE]);
      close(tube[SORTIE]);
   
      execvp(argv[1],&argv[1]);
      /* Jaimais atteint sauf erreur */
      fprintf(stderr,"Erreur dans %s %s ... ", argv[0],argv[1]);
      perror("");
      exit(EXIT_FAILURE);
    }
  /* Atteint par le pre */
  exit(EXIT_SUCCESS);
}
